Index: Firefox/12.0/search_bar.ahk
===================================================================
--- Firefox/12.0/search_bar.ahk	(revision 2344)
+++ Firefox/12.0/search_bar.ahk	(working copy)
@@ -55,13 +55,13 @@
                 else
                 {
                     if clipboard <> edijus
-                        TestsFailed("Clipboard content is not the same as expected (is '" clipboard "', should be 'edijus') Can't focus serch bar using Ctrl+K?.")
+                        TestsFailed("Clipboard content is not the same as expected (is '" clipboard "', should be 'edijus') Can't focus search bar using Ctrl+K?.")
                     else
                     {
                         SendInput, {ENTER}
-                        WinWaitActive, edijus - Yahoo! Search Results - Mozilla Firefox,,15 ; Time depends on connection speed
+                        WinWaitActive, edijus - Yahoo Search Results - Mozilla Firefox,,15 ; Time depends on connection speed
                         if ErrorLevel
-                            TestsFailed("'edijus - Yahoo! Search Results - Mozilla Firefox' window failed to appear, so, search bar do not work. Bug #CORE-6342?")
+                            TestsFailed("'edijus - Yahoo Search Results - Mozilla Firefox' window failed to appear, so, search bar does not work. Bug #CORE-6342?")
                         else
                         {
                             Sleep, 5500 ; Let the URL to load, maybe something will fail
@@ -70,7 +70,7 @@
                             if ErrorLevel ; The PID still exists.
                                 TestsFailed("Unable to terminate '" ProcessExe "' process.")
                             else
-                                TestsOK("'edijus - Yahoo! Search Results - Mozilla Firefox' window appeared, so search bar works, '" ProcessExe "' process closed.")
+                                TestsOK("'edijus - Yahoo Search Results - Mozilla Firefox' window appeared, so search bar works, '" ProcessExe "' process closed.")
                         }
                     }
                 }
Index: Firefox/2.0.0.20/address_bar.ahk
===================================================================
--- Firefox/2.0.0.20/address_bar.ahk	(revision 2344)
+++ Firefox/2.0.0.20/address_bar.ahk	(working copy)
@@ -38,8 +38,8 @@
             TestsFailed("The attempt to copy text onto the clipboard failed.")
         else
         {
-            if clipboard <> http://start.mozilla.org/en-US/
-                TestsFailed("Clipboard content is not the same as expected (is '" clipboard "', should be 'http://start.mozilla.org/en-US/') Can't focus address bar using Alt+D?.")
+            if clipboard <> https://start.mozilla.org/en-US/
+                TestsFailed("Clipboard content is not the same as expected (is '" clipboard "', should be 'https://start.mozilla.org/en-US/') Can't focus address bar using Alt+D?.")
             else
             {
                 SendInput, http{:}//dsx86{.}patrickaalto{.}com{ENTER}
Index: Firefox/2.0.0.20/download.ahk
===================================================================
--- Firefox/2.0.0.20/download.ahk	(revision 2344)
+++ Firefox/2.0.0.20/download.ahk	(working copy)
@@ -40,7 +40,6 @@
         else
         {
             SendInput, {CTRLDOWN}l{CTRLUP}%szURL%{ENTER} ;Download some file
-            
             WinWaitActive, Opening %szFileName%,,10
             if ErrorLevel
                 TestsFailed("'Opening " szFileName "' window failed to appear, so, downloading failed.")
Index: Firefox/2.0.0.20/install_test.ahk
===================================================================
--- Firefox/2.0.0.20/install_test.ahk	(revision 2344)
+++ Firefox/2.0.0.20/install_test.ahk	(working copy)
@@ -134,13 +134,12 @@
         }
     }
 
-
     if bContinue
     {
         RegDelete, HKEY_LOCAL_MACHINE, SOFTWARE\Mozilla
-            RegDelete, HKEY_LOCAL_MACHINE, SOFTWARE\mozilla.org
-            RegDelete, HKEY_LOCAL_MACHINE, SOFTWARE\MozillaPlugins
-            RegDelete, HKEY_LOCAL_MACHINE, SOFTWARE\MicroSoft\Windows\CurrentVersion\Uninstall\Mozilla Firefox (2.0.0.20)
+        RegDelete, HKEY_LOCAL_MACHINE, SOFTWARE\mozilla.org
+        RegDelete, HKEY_LOCAL_MACHINE, SOFTWARE\MozillaPlugins
+        RegDelete, HKEY_LOCAL_MACHINE, SOFTWARE\MicroSoft\Windows\CurrentVersion\Uninstall\Mozilla Firefox (2.0.0.20)
         IfExist, %A_AppData%\Mozilla
         {
             FileRemoveDir, %A_AppData%\Mozilla, 1
@@ -193,7 +192,7 @@
     {
         ControlClick, Button2
         if ErrorLevel
-            TestsFailed("Unable to hit 'Next' in 'Mozilla Firefox Setup (Welcome to the Mozilla Firefox)' window.")
+            TestsFailed("Unable to click 'Next' button in 'Mozilla Firefox Setup (Welcome to the Mozilla Firefox)' window.")
         else
             TestsOK("'Mozilla Firefox Setup (Welcome to the Mozilla Firefox)' window appeared and 'Next' button was clicked.")
     }
@@ -215,7 +214,7 @@
             TestsFailed("Unable to check 'I accept' radio button in 'License Agreement' window.")
         else
         {
-            Sleep, 300 ; Give some time for 'Next' to get enabled
+            Sleep, 300 ; Give some time for 'Next' button to get enabled
             ControlGet, OutputVar, Enabled,, Button2
             if not %OutputVar%
                 TestsFailed("'I accept' radio button is checked in 'License Agreement', but 'Next' button is disabled.")
@@ -223,7 +222,7 @@
             {
                 ControlClick, Button2
                 if ErrorLevel
-                    TestsFailed("Unable to hit 'Next' button in 'Mozilla Firefox Setup (License Agreement)' window despite it is enabled.")
+                    TestsFailed("Unable to click 'Next' button in 'Mozilla Firefox Setup (License Agreement)' window despite it is enabled.")
                 else
                     TestsOK("'Mozilla Firefox Setup (License Agreement)' window appeared and 'Next' button was clicked.")
             }
@@ -243,7 +242,7 @@
     {
         ControlClick, Button2
         if ErrorLevel
-            TestsFailed("Unable to hit 'Next' in 'Mozilla Firefox Setup (Setup Type)' window.")
+            TestsFailed("Unable to click 'Next' button in 'Mozilla Firefox Setup (Setup Type)' window.")
         else
             TestsOK("'Mozilla Firefox Setup (Setup Type)' window appeared and 'Next' button was clicked.")
     }
@@ -288,19 +287,19 @@
         {
             ControlGet, bChecked, Checked,, Button4
             if bChecked = 1
-                TestsFailed("'Lounch Firefox now' checkbox in 'Mozilla Firefox Setup (Completing)' window reported as unchecked, but further inspection proves that it was still checked.")
+                TestsFailed("'Launch Firefox now' checkbox in 'Mozilla Firefox Setup (Completing)' window reported as unchecked, but further inspection proves that it was still checked.")
             else
             {
-                ControlClick, Button2 ; Hit 'Finish'
+                ControlClick, Button2 ; Click 'Finish'
                 if ErrorLevel
-                    TestsFailed("Unable to hit 'Finish' button in 'Mozilla Firefox Setup (Completing)' window.")
+                    TestsFailed("Unable to click 'Finish' button in 'Mozilla Firefox Setup (Completing)' window.")
                 else
                 {
                     WinWaitClose,,, 5
                     if ErrorLevel
                         TestsFailed("'Mozilla Firefox Setup (Completing)' window failed to close despite 'Finish' button being clicked.")
                     else
-                        TestsOK("'Mozilla Firefox Setup (Completing)' window appeared, 'Lounch Firefox now' checkbox unchecked, 'Finish' button clicked, window closed.")
+                        TestsOK("'Mozilla Firefox Setup (Completing)' window appeared, 'Launch Firefox now' checkbox unchecked, 'Finish' button clicked, window closed.")
                 }
             }
         }
Index: Firefox/2.0.0.20/search_bar.ahk
===================================================================
--- Firefox/2.0.0.20/search_bar.ahk	(revision 2344)
+++ Firefox/2.0.0.20/search_bar.ahk	(working copy)
@@ -55,13 +55,13 @@
                 else
                 {
                     if clipboard <> edijus
-                        TestsFailed("Clipboard content is not the same as expected (is '" clipboard "', should be 'edijus') Can't focus serch bar using Ctrl+K?.")
+                        TestsFailed("Clipboard content is not the same as expected (is '" clipboard "', should be 'edijus') Can't focus search bar using Ctrl+K?.")
                     else
                     {
                         SendInput, {ENTER}
-                        WinWaitActive, edijus - Yahoo! Search Results - Mozilla Firefox,,15 ; Time depends on connection speed
+                        WinWaitActive, edijus - Yahoo Search Results - Mozilla Firefox,,15 ; Time depends on connection speed
                         if ErrorLevel
-                            TestsFailed("'edijus - Yahoo! Search Results - Mozilla Firefox' window failed to appear, so, search bar do not work. Bug #CORE-6342?")
+                            TestsFailed("'edijus - Yahoo Search Results - Mozilla Firefox' window failed to appear, so, search bar does not work. Bug #CORE-6342?")
                         else
                         {
                             Sleep, 5500 ; Let the URL to load, maybe something will fail
@@ -70,7 +70,7 @@
                             if ErrorLevel ; The PID still exists.
                                 TestsFailed("Unable to terminate '" ProcessExe "' process.")
                             else
-                                TestsOK("'edijus - Yahoo! Search Results - Mozilla Firefox' window appeared, so search bar works, '" ProcessExe "' process closed.")
+                                TestsOK("'edijus - Yahoo Search Results - Mozilla Firefox' window appeared, so search bar works, '" ProcessExe "' process closed.")
                         }
                     }
                 }
Index: Firefox/3.0.11/download.ahk
===================================================================
--- Firefox/3.0.11/download.ahk	(revision 2344)
+++ Firefox/3.0.11/download.ahk	(working copy)
@@ -40,7 +40,6 @@
         else
         {
             SendInput, {CTRLDOWN}l{CTRLUP}%szURL%{ENTER} ;Download some file
-            
             WinWaitActive, Opening %szFileName%,,10
             if ErrorLevel
                 TestsFailed("'Opening " szFileName "' window failed to appear, so, downloading failed.")
Index: Firefox/3.0.11/install_test.ahk
===================================================================
--- Firefox/3.0.11/install_test.ahk	(revision 2344)
+++ Firefox/3.0.11/install_test.ahk	(working copy)
@@ -137,9 +137,9 @@
     if bContinue
     {
         RegDelete, HKEY_LOCAL_MACHINE, SOFTWARE\Mozilla
-            RegDelete, HKEY_LOCAL_MACHINE, SOFTWARE\mozilla.org
-            RegDelete, HKEY_LOCAL_MACHINE, SOFTWARE\MozillaPlugins
-            RegDelete, HKEY_LOCAL_MACHINE, SOFTWARE\MicroSoft\Windows\CurrentVersion\Uninstall\Mozilla Firefox (3.0.11)
+        RegDelete, HKEY_LOCAL_MACHINE, SOFTWARE\mozilla.org
+        RegDelete, HKEY_LOCAL_MACHINE, SOFTWARE\MozillaPlugins
+        RegDelete, HKEY_LOCAL_MACHINE, SOFTWARE\MicroSoft\Windows\CurrentVersion\Uninstall\Mozilla Firefox (3.0.11)
         IfExist, %A_AppData%\Mozilla
         {
             FileRemoveDir, %A_AppData%\Mozilla, 1
@@ -192,9 +192,9 @@
     {
         ControlClick, Button2
         if ErrorLevel
-            TestsFailed("Unable to hit 'Next' button in 'Mozilla Firefox Setup (Welcome to the Mozilla Firefox)' window.")
+            TestsFailed("Unable to click 'Next' button in 'Mozilla Firefox Setup (Welcome to the Mozilla Firefox)' window.")
         else
-            TestsOK("'Mozilla Firefox Setup (Welcome to the Mozilla Firefox)' window appeared and 'Next' was clicked.") 
+            TestsOK("'Mozilla Firefox Setup (Welcome to the Mozilla Firefox)' window appeared and 'Next' button was clicked.")
     }
 }
 
@@ -210,9 +210,9 @@
     {
         ControlClick, Button2
         if ErrorLevel
-            TestsFailed("Unable to hit 'Next' button in 'Mozilla Firefox Setup (Setup Type)' window.")
+            TestsFailed("Unable to click 'Next' button in 'Mozilla Firefox Setup (Setup Type)' window.")
         else
-            TestsOK("'Mozilla Firefox Setup (Setup Type)' window appeared and 'Next' was clicked.")
+            TestsOK("'Mozilla Firefox Setup (Setup Type)' window appeared and 'Next' button was clicked.")
     }
 }
 
@@ -226,9 +226,9 @@
         TestsFailed("'Mozilla Firefox Setup (Summary)' window failed to appear.")
     else
     {
-        ControlClick, Button2 ; Hit 'Install' button
+        ControlClick, Button2 ; Click 'Install' button
         if ErrorLevel
-            TestsFailed("Unable to hit 'Install' button in 'Mozilla Firefox Setup (Summary)' window.")
+            TestsFailed("Unable to click 'Install' button in 'Mozilla Firefox Setup (Summary)' window.")
         else
             TestsOK("'Mozilla Firefox Setup (Summary)' window appeared and 'Install' button was clicked.")
     }
@@ -274,19 +274,19 @@
         {
             ControlGet, bChecked, Checked,, Button4
             if bChecked = 1
-                TestsFailed("'Lounch Firefox now' checkbox in 'Mozilla Firefox Setup (Completing)' window reported as unchecked, but further inspection proves that it was still checked.")
+                TestsFailed("'Launch Firefox now' checkbox in 'Mozilla Firefox Setup (Completing)' window reported as unchecked, but further inspection proves that it was still checked.")
             else
             {
-                ControlClick, Button2 ; Hit 'Finish'
+                ControlClick, Button2 ; Click 'Finish'
                 if ErrorLevel
-                    TestsFailed("Unable to hit 'Finish' button in 'Mozilla Firefox Setup (Completing)' window.")
+                    TestsFailed("Unable to click 'Finish' button in 'Mozilla Firefox Setup (Completing)' window.")
                 else
                 {
                     WinWaitClose,,, 5
                     if ErrorLevel
                         TestsFailed("'Mozilla Firefox Setup (Completing)' window failed to close despite 'Finish' button being clicked.")
                     else
-                        TestsOK("'Mozilla Firefox Setup (Completing)' window appeared, 'Lounch Firefox now' checkbox unchecked, 'Finish' button clicked, window closed.")
+                        TestsOK("'Mozilla Firefox Setup (Completing)' window appeared, 'Launch Firefox now' checkbox unchecked, 'Finish' button clicked, window closed.")
                 }
             }
         }